using System;
using System.Collections;
using System.IO;
using System.Text.RegularExpressions;
using Gtk;
using Gdk;
using System.Text;
namespace GtkDemo
{
	//[Demo ("List Store", "DemoListStore.cs", "Tree View")]
	public class DemoListStore : Gtk.Window
	{
		public static ListStore store;
		public static void Main(string[] args){
			Application.Init();
			new DemoListStore();
			Application.Run();
		}
		
		private static StatusIcon trayIcon;

		public DemoListStore () : base ("ListStore Demo")
		{
			BorderWidth = 8;

			VBox vbox = new VBox (false, 8);
			Add (vbox);
			HBox hb = new HBox(false,4);
			vbox.PackStart(hb,false,true,0);
			Label l= new Label("              ");
			hb.PackStart(l,false,true,0);
			Button openfile=new Button("Refresh");
			Label l1= new Label("              ");
			Label l2= new Label("              ");
			Button memusage = new Button("Show Memory Status");
			Button close = new Button("Close");
			hb.PackStart(openfile,false,true,0);
			//hb.PackStart(l1,false,true,0);
			hb.PackStart(memusage,false,true,0);
			//hb.PackStart(l2,false,true,0);
			hb.PackStart(close,false,true,0);
			
			trayIcon = new StatusIcon(new Pixbuf("etm.png"));
			trayIcon.Visible = true;
			
			trayIcon.Activate += delegate { this.Visible = !this.Visible; };
			

//			Label label = new Label ("This is the bug list (note: not based on real data, it would be nice to have a nice ODBC interface to bugzilla or so, though).");
//			vbox.PackStart (label, false, false, 0);

			ScrolledWindow sw = new ScrolledWindow ();
			sw.ShadowType = ShadowType.EtchedIn;
			sw.SetPolicy (PolicyType.Automatic, PolicyType.Automatic);
			vbox.PackStart (sw, true, true, 0);

                        // create model
			store = CreateModel ();

			// create tree view
			TreeView treeView = new TreeView (store);
			treeView.RulesHint = true;
			treeView.SearchColumn = (int) Column.ExecutionTime;
			sw.Add (treeView);

			AddColumns (treeView);
			//events
			
			//DeleteEvent += new DeleteEventHandler(MainWindowDeleteEvent);
			openfile.Clicked += new EventHandler(onButtonClick);
			memusage.Clicked +=new EventHandler(showMemUsage);
			close.Clicked += new EventHandler(closeEvent);

			// finish & show
			SetDefaultSize (400, 400);
			ShowAll ();
		}

		private void FixedToggled (object o, ToggledArgs args)
		{
			Gtk.TreeIter iter;
			if (store.GetIterFromString (out iter, args.Path)) {
				bool val = (bool) store.GetValue (iter, 0);
				store.SetValue (iter, 0, !val);
			}
		}

		private void AddColumns (TreeView treeView)
		{
			// column for process id
			CellRendererToggle rendererToggle = new CellRendererToggle ();
			rendererToggle.Toggled += new ToggledHandler (FixedToggled);
			TreeViewColumn column =  new TreeViewColumn ("Fixed?", rendererToggle, "active", Column.Priority);
			CellRendererText rendererText = new CellRendererText ();
			column = new TreeViewColumn ("Process ID", rendererText, "text", Column.ProcessID);
			column.SortColumnId = (int) Column.ProcessID;
			treeView.AppendColumn (column);
			// column for process name
			rendererText = new CellRendererText ();
			column = new TreeViewColumn ("ProcessName", rendererText, "text", Column.ProcessName);
			column.SortColumnId = (int) Column.ProcessName;
			treeView.AppendColumn (column);

			// column for priorities
			rendererText = new CellRendererText ();
			column = new TreeViewColumn ("Priority", rendererText, "text", Column.Priority);
			column.SortColumnId = (int) Column.Priority;
			treeView.AppendColumn(column);

			// column for execution time
			rendererText = new CellRendererText ();
			column = new TreeViewColumn ("ExecutionTime", rendererText, "text", Column.ExecutionTime);
			column.SortColumnId = (int) Column.ExecutionTime;
			treeView.AppendColumn (column);
		}

		protected override bool OnDeleteEvent (Gdk.Event evt)
		{
			Destroy ();
			return true;
		}

		private ListStore CreateModel ()
		{
			ListStore store = new ListStore (typeof(int),
							 typeof(string),
							 typeof(int),
							 typeof(double));

			foreach (Bug bug in bugs) {
				store.AppendValues (bug.ProcessID,
						    bug.ProcessName,
						    bug.Priority,
						    bug.ExecutionTime);
			}

			return store;
		}

		private enum Column
		{
			ProcessID,
			ProcessName,
			Priority,
			ExecutionTime
		}

		public static Bug[] bugs =
		{
			new Bug(0," ",0,0.0)
		};
		void onButtonClick (object o, EventArgs args){
			
			store.Clear();
			Program p = new Program();
			DirectoryInfo dir = new DirectoryInfo(@"/proc");
			int count = p.ExploreDir(dir);
			FileReader file = new FileReader();
			file.read(count+1);
			Details d = new Details();
			string[,] info = new string[count+1,4];
			info= d.getDetails(count+1);
			//for(int i=0;i<count+1;i++){
			//	for(int j=0;j<4;j++){
			//		Console.Write("{0}\t",info[i,j]);
			//	}
			//	Console.WriteLine();
			//}
			//bugs = new Bug[count+1];
			int limit=0;
			for(int i=0;i<count+1;i++,limit++){
				bugs=new Bug[]{new Bug(Convert.ToInt32(info[limit,0]),info[limit,1],Convert.ToInt32(info[limit,2]),Convert.ToDouble(info[limit,3]))};
				foreach (Bug bug in bugs) {
				DemoListStore.store.AppendValues (bug.ProcessID,
						    bug.ProcessName,
						    bug.Priority,
						    bug.ExecutionTime);
				}					
			}
			//bugs = new Bug[] { new Bug(0," ",0,0.0) };
		}
		void showMemUsage(object o, EventArgs args){
			//buffer.Buffer.Text = "";
			//store.Clear();
			ShowMemInfo();
		}
		void closeEvent(object o, EventArgs args){
			Application.Quit();
		}
		public void ShowMemInfo(){
			Application.Init();
			new MemInfo();
			Application.Run();
		}
	}
	public class Details{
		
		public string[,] getDetails(int limit){
			TextReader reader = new StreamReader("processinfo.txt");
			string[,] info =new string[limit,4];
			string str;
			int count=0;
			char[] delimiter={'\t'};
			while((str=reader.ReadLine())!=null){
				
				string[] arr = new string[4];
				arr = str.Split(delimiter);
				for(int i=0;i<4;i++){
					info[count,i]=arr[i];
				}
				count++;
			}
			return info;
		}
	}

	public class Bug
	{
		public int ProcessID;
		public string ProcessName;
		public int Priority;
		public double ExecutionTime;

		public Bug (int status, string number, int severity,
			    double description)
		{
			ProcessID = status;
			ProcessName = number;
			Priority = severity;
			ExecutionTime = description;
		}
	}
	public class FileReader{
		
		public void read(int limit){
			
			string str;
			TextWriter writer = new StreamWriter("processinfo.txt");
			TextReader tr = new StreamReader("dirs.txt");
			int count=1;
			while(((str=tr.ReadLine())!=null)){
				
				string s1 = "/proc/";
				string s2="/stat";
				char[] delimiter={' '};
				string temp = string.Concat(s1,str);
				string path = string.Concat(temp,s2);
				TextReader reader ;
				reader = new StreamReader(path);
				string file_contents = reader.ReadToEnd();
				string[] array= file_contents.Split(delimiter);
				//Console.WriteLine();
				//Console.Write(array[0]);
				//Console.Write("\t{0}",array[1]);
				//Console.Write("\t{0}",array[15]);
				//Console.Write("\t{0}\n",Convert.ToInt32(array[13])+Convert.ToInt32(array[14]));
				reader.Close();
				writer.Write(array[0]);
				writer.Write("\t{0}",array[1].Substring(1,array[1].Length-2));
				writer.Write("\t{0}",array[15]);
				writer.Write("\t{0}\n",Convert.ToInt32(array[13])+Convert.ToInt32(array[14]));
				//Console.WriteLine("------------------------------");
				count++;
			}
			//Console.WriteLine(count-1);
			writer.Close();
			tr.Close();
		}
	}
	class Program
	{
		public int ExploreDir(DirectoryInfo dir){
			int count=0;
			StreamWriter tex = new StreamWriter("dirs.txt",false);
			Regex reg = new Regex(@"^[0-9][0-9]*[0-9]$");
			DirectoryInfo[] dirs = dir.GetDirectories();
			//Console.WriteLine("{0} directories are present",dirs.Length);
			foreach ( DirectoryInfo nd in dirs){
				MatchCollection matches = reg.Matches(nd.Name);
				foreach ( Match thematch in matches){
					if(thematch.Length!=0){
						count++;
						string name = nd.Name;
			//			Console.WriteLine(name);
						tex.WriteLine(name);
					}
				}
			}
			tex.Close();
			return count-1;
		}
	}
	public class MemInfo{
		public static int count=0;
		public MemInfo(){
			Gtk.Window mem_win = new Gtk.Window("Memory Usage Statistics");
			VBox vbox = new VBox(false,4);
			mem_win.SetDefaultSize(300,100);
			TextView viewer = new TextView();
			viewer.Editable = false;
			mem_win.Add(vbox);
			
			//DrawingArea area = new DrawingArea();
			//Cairo.Graphics g = Gtaphics.CreateDrawable(area.GdkWindow);
			vbox.PackStart(viewer,true,true,0);
			//string[] parameters = new string[4];
			int i=0;
			for(i=0;i<1000000;i++){
				if(i%500==0){
			readInfo();
			TextReader file = new StreamReader("meminfo");
			viewer.Buffer.Text=file.ReadToEnd();
			file.Close();
					mem_win.ShowAll();
				}
			}
		}
		public void readInfo(){
			TextReader reader = new StreamReader("/proc/meminfo",false);
			string[] meminfo = new string[40];
			string line="";
			count=0;
			TextWriter file = new StreamWriter("meminfo");
			while((line=reader.ReadLine())!=null){
				//line = line.Replace(" ","");
				//line = line.Replace("kB","");
				//char[] delimit={':'};
				//string[] str=new string[2];
				//str=line.Split(delimit);
				file.WriteLine(line);
			}
			reader.Close();
			file.Close();
		}
	}
}
