/* tabdialog.h 
 *
 * Copyright (C) 2008  Eshwari C
 *
 * Licensed under the Academic Free License version 2.1
 *
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 *
 *
 */
 	
#ifndef TABDIALOG_H
#define TABDIALOG_H

#include <qtabdialog.h>
#include <qstring.h>
#include <qfileinfo.h>
#include <qvbox.h>
#include<qtable.h>
#include<qpainter.h>
class TabDialog : public QTabDialog
{
    Q_OBJECT

public:
    TabDialog( QWidget *parent, const char *name, const QString &_filename );
	QVBox *tab1;
	QVBox *tab2;
	QVBox *tab3;
	QTable *ProcessTable;
	QTable *MemoryTable;
	QPainter *paint1;
protected:
    QString filename;
    QFileInfo fileinfo;

    void setupTab1();
    void setupTab2();
    void setupTab3();
    void paintEvent(QPaintEvent *);	
    void  fillTable(QTable *);
    void CPUAggregates(unsigned long*,unsigned long*,unsigned long*,unsigned long*);
    void drawScale(int,int,int,QPainter*);
    void fillArray(int*,int);
    void fillArray(unsigned long long *,unsigned long long);
    void fillArray(double*,double);    
    int *arraycu;
    int *arraycs;
    int *arrayci;
    int *arraycw;
    unsigned long long *arraypagefaults;
    double *ratio;
    void drawArray(int*,int,int,int,int,QPainter*);
    void drawMemoryScale(int beg,int end,int x,QPainter*);
    void drawMemoryScale(int,int,int,QPainter*,int);
    void fillMemoryTable(QTable* table);
    void drawMemoryArray(unsigned long long *arr,int x,int beg,int end,QPainter *);
    void drawMemoryArray(double *arr,int x,int beg,int end,QPainter *);
    void InitializeMemoryArray();
    void MemoryAggregates(unsigned long long *,unsigned long long *,unsigned long long*);
    void VMCalculation(unsigned long long ,unsigned long long ,unsigned long long);
    unsigned long long memory(QString);
public slots:
	void timeout();
	
};

#endif
